﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace MultiSelectListBindingProblem
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			DataContext = _dataContext;
		}

		TestDataContext _dataContext = new TestDataContext();

		private void TestSelectAll_Click(object sender, RoutedEventArgs e)
		{
			foreach (var item in _dataContext.Items)
				item.IsSelected = true;
		}
	}

	public class TestItem : NPCHelper
	{
		TestDataContext _c;
		string _text;
		public TestItem(TestDataContext c, string text) { _c = c; _text = text; }

		public override string ToString() { return _text; }

		public string Text { get { return _text; } }

		bool _isSelected;
		public bool IsSelected
		{
			get { return _isSelected; }
			set {
				_isSelected = value;
				FirePropertyChanged("IsSelected");
				_c.FirePropertyChanged("NumItemsSelected");
			}
		}
	}

	public class TestDataContext : NPCHelper
	{
		public TestDataContext()
		{
			for (int i = 0; i < 100; i++)
				_items.Add(new TestItem(this, i.ToString()));
		}
		ObservableCollection<TestItem> _items = new ObservableCollection<TestItem>();
		public ObservableCollection<TestItem> Items { get { return _items; } }

		public int NumItemsSelected { get { return _items.Where(it => it.IsSelected).Count(); } }
	}

	public class NPCHelper : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;
		public void FirePropertyChanged(string prop)
		{
			if (PropertyChanged != null)
				PropertyChanged(this, new PropertyChangedEventArgs(prop));
		}
	}
}
